<template>
  <div class="card mb-5 mb-xl-8 mt-5 shadow-sm">
    <div class="card-header d-flex flex-column flex-md-row border-2 pt-5">
      <h3 class="card-title align-items-start flex-column">
        <span class="card-label fw-bolder fs-3 mb-1">Subasta</span>
        <span class=" text-muted mt-1 fs-7">Hay {{ subastas.length }} registros</span>
      </h3>
      <div class="card-toolbar d-flex flex-nowrap justify-content-end">
        <div class="position-relative w-150px w-xl-250px w-xxl-400px me-2 flex-fill">
          <span class="svg-icon svg-icon-3 svg-icon-gray-500 position-absolute top-50 translate-middle ms-6">
            <i class="bi bi-search" />
          </span>
          <input
            v-model="busqueda"
            type="text"
            class="form-control ps-10"
            placeholder="Buscar"
          >
        </div>
        <div>
          <button
            class="btn btn-primary bg-hover-primary"
            @click="onFiltrarBusqueda()"
          >
            <i class="bi bi-search" />Buscar
          </button>
        </div>
      </div>
    </div>

    <div class="card-body py-3">
      <div
        v-if="response.listar === 'LOADING'"
        class="d-flex justify-content-center py-20"
      >
        <div
          class="spinner-border text-primary"
          style="width: 4rem; height: 4rem; border-width: 0.35rem"
          role="status"
        >
          <span class="visually-hidden">Cargando...</span>
        </div>
      </div>

      <div
        v-else
        class="table-responsive"
      >
        <table class="table table-hover table-row-bordered table-row-gray-300 gy-7">
          <thead>
            <tr class="fw-bolder fs-6 text-gray-800">
              <th class="ps-4 min-w-100px">
                #
              </th>
              <th class="min-w-300px">
                Título
              </th>
              <th class="min-w-200px text-center">
                Fecha de remate
              </th>
              <th class="min-w-200px text-center">
                Hora de remate
              </th>
              <th class="min-w-200px text-center rounded-end">
                Opciones
              </th>
            </tr>
          </thead>
          <tbody>
            <tr
              v-for="subasta in pSubastas"
              :key="subasta.id"
            >
              <td>
                <div class="d-flex justify-content-start flex-column ps-4">
                  <span
                    class="text-black mb-1 fs-6"
                    v-text="subasta.id"
                  />
                </div>
              </td>
              <td>
                <span
                  class="text-dark text-start d-block mb-1 fs-6"
                  v-text="subasta.titulo"
                />
              </td>
              <td>
                <span
                  class="text-dark text-center d-block mb-1 fs-6"
                  v-text="subasta.fechaRemate"
                />
              </td>
              <td>
                <span
                  class="text-dark text-center d-block mb-1 fs-6"
                  v-text="subasta.horaRemate"
                />
              </td>
              <td class="text-center">
                <router-link
                  :to="{ name: 'panel.subasta.mostrar', params: { id: subasta.id }}"
                  class="btn btn-icon btn-bg-light btn-active-color-primary btn-sm me-1"
                >
                  <i class="bi bi-file-text-fill" />
                </router-link>

                <router-link
                  :to="{ name: 'panel.subasta.editar', params: { id: subasta.id }}"
                  class="btn btn-icon btn-bg-light btn-active-color-warning btn-sm me-1"
                >
                  <i class="bi bi-pencil-square" />
                </router-link>

                <button
                  class="btn btn-icon btn-bg-light btn-active-color-danger btn-sm"
                  data-bs-toggle="modal"
                  data-bs-target="#modal_subasta_eliminar"
                  @click="onEliminar(subasta)"
                >
                  <i class="bi bi-trash-fill" />
                </button>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <div class="card-footer border-2 pt-4 pb-4">
      <paginacion
        ref="tablaSubastaListarPaginacion"
        :cantidades="[5,10,50,100]"
        :datos="subastasFiltro"
        @on-mostrar-pagina="onMostrarPagina"
      />
    </div>
  </div>
</template>
<script>
import Ruta from "@/core/servicio/Ruta";
import Servicio from "@/core/servicio/Servicio";
import Paginacion from "@/components/util/Paginacion2";
import TablaFila from "@/core/util/TablaFila";
import Toast from "@/core/util/Toast";

export default {
  name: 'TablaSubastaListar',
  components: {
    Paginacion
  },
  emits: ['onSubastaEliminar'],
  data() {
    return {
      subastas: [],
      subastasFiltro: [],
      pSubastas: [],
      busqueda: '',
      response: {
        listar: 'LOADING',
      }
    }
  },

  mounted() {
    this.onSubastaListar();
  },
  methods: {
    onSubastaListar() {
      this.response.listar = 'LOADING';
      Servicio.get(Ruta.PANEL_SUBASTA_LISTAR).then( (data) => {
        this.subastas = data.data;
        this.subastasFiltro = this.subastas;
        this.response.listar = data.estado;
      }).catch( (error) => {
        this.response.listar = 'ERROR';
        Toast.mostrarError(error);
      });
    },

    onEliminar(subasta) {
      this.$emit('onSubastaEliminar', subasta);
    },

    onMostrarPagina(datos) {
      this.pSubastas = datos;
    },

    onFiltrarBusqueda() {
      this.subastasFiltro = TablaFila.getBusquedaFila(this.subastas, this.busqueda, ['id','titulo','fechaRemate','horaRemate']);
    }
  },
}

</script>